// I2C GT911/GT915 
// Сергей Бакаев(ser8989)
// 
// Использование библиотеки Wire для чтения/записи данных из
// GT911 или GT915

// Создано март 2021 г.
// 

#include <Wire.h>
#define len 93

void setup() {
  Wire.begin();                // join i2c bus (address optional for master)
  Serial.begin(74880);          // start serial communication at 74880bps
  Serial.println("Type comand (READ or WRITE)");
}

byte GT911_CFG_TBL[len];


void GT911_WR_Reg(int reg, byte val)//, char *buf
{
  char addr[2] = {(char)(reg >> 8), (char)reg};
  Wire.beginTransmission(0x5d); // transmit to device #93 (0x5d)
     
  Wire.write(addr,2);// sets register pointer to echo #x register (0xXX)
  Wire.write(val);
  Wire.endTransmission();      // stop transmitting
}

boolean GT911_RD_Reg(int reg, int leng)//, char *buf
{
  char addr[2] = {(char)(reg >> 8), (char)reg};
  
  Wire.beginTransmission(0x5d); // transmit to device #93 (0x5d)
    
  Wire.write(addr,2);// sets register pointer to echo #x register (0xXX)
  Wire.endTransmission();      // stop transmitting
  //
  Wire.requestFrom(0x5d, leng);    // запрашиваем у ведомого устройства #5d len байт

  if (Wire.available() == 0) {
    return false;
  }else{
    while(1 <= Wire.available())    // ведомое устройство может отправить не все запрашиваемые байты
    { 
      for (int i = 0; i < leng; i++){
        GT911_CFG_TBL[i] = Wire.read();
      }
    
      for (int i = 0; i < leng; i++){
        //Serial.print(i, DEC);
        
        ;Serial.print("0x");Serial.print(GT911_CFG_TBL[i],HEX);Serial.print(",");
        //Serial.println();        // выводим символ
      }
    }
    return true;
  }

}

void WriteConf(){
  Serial.println("Write configuration start");
  //GT911_WR_Reg(0x804D,0xFD);//Module_Switch1 
  
  GT911_WR_Reg(0x80B7,0x02);
  GT911_WR_Reg(0x80B8,0x04);
  GT911_WR_Reg(0x80B9,0x06);
  GT911_WR_Reg(0x80BA,0x08);
  GT911_WR_Reg(0x80BB,0x0A);
  GT911_WR_Reg(0x80BC,0x0C);
  GT911_WR_Reg(0x80BD,0x0E);
  GT911_WR_Reg(0x80BE,0x10);
  GT911_WR_Reg(0x80BF,0x12);
  GT911_WR_Reg(0x80C0,0x14);

  GT911_WR_Reg(0x80D5,0x00);
  GT911_WR_Reg(0x80D6,0x02);
  GT911_WR_Reg(0x80D7,0x04);
  GT911_WR_Reg(0x80D8,0x06);
  GT911_WR_Reg(0x80D9,0x08);
  GT911_WR_Reg(0x80DA,0x0A);
  GT911_WR_Reg(0x80DB,0x0C);
  GT911_WR_Reg(0x80DC,0x1D);
  GT911_WR_Reg(0x80DD,0x1E);
  GT911_WR_Reg(0x80DE,0x1F);
  GT911_WR_Reg(0x80DF,0x20);
  GT911_WR_Reg(0x80E0,0x21);
  GT911_WR_Reg(0x80E1,0x22);
  GT911_WR_Reg(0x80E2,0x24);
  GT911_WR_Reg(0x80E3,0x26);
  GT911_WR_Reg(0x80E4,0x28);
  
  GT911_WR_Reg(0x8100,0x01);
  Serial.println("Write configuration end");
}

boolean ReadConf(){
  Serial.println("Read configuration start");
  if (GT911_RD_Reg(0x8047,len)){//, char *buf
    if (GT911_RD_Reg(0x80a4,len)){//, char *buf
      Serial.println("");
      Serial.println("Read configuration successful");
      return true;    
    }
  }
  Serial.println("Read configuration Error!");
  return false;
}

void loop() {
  
  //delay(2000);
  
  //if(ReadConf()){
     //WriteConf();
     //ReadConf();
  //}
  
  //while(1){yield();};
  //delay(30000);

  if (Serial.available()) {
    String command = Serial.readString();
    Serial.println(command);
    if (command.equalsIgnoreCase("READ")){
      ReadConf();  
    }
    if (command.equalsIgnoreCase("WRITE")){
      if(ReadConf()){
        WriteConf();
        ReadConf();
      }
    }
  }
}  
